#!/usr/bin/env python

import os, sys
from os import system
from string import find, split, atof, atoi
from time import time

# parameters
seed = 1
cstart = 0.25
ctimes = 4
cstep = 4
eps_list = [0.1, 0.001]

data_list = ['data/a9a', 'data/w8a', 'data/real-sim.svml', 'data/news20.binary', 'data/train308.scale', 'data/rcv1_test.binary', 'data/leisure.scale']
data_list = ['data/a9a']
classifiers_list = ['liblr_row/runlrtrain_row', 'liblr_col/runlrtrain_col', 'lbfgs/runlbfgs', 'svmlin-v1.0/svmlin', 'liblr_l2/runlrtrain_l2']

for data in data_list:
#     texfile = open("%s.tex" % (data), 'w', 0)
#     texfile.write('\\begin{tabular}{rrrrr}\n')
    data_name = (os.path.split(data))[1]
    if data_name == 'rcv1_test.binary' or data_name == 'train308.scale' or data_name == 'Blanc__Mel.txt' or data_name == 'leisure.scale':
        nfold = 2
    else:
        nfold = 5
    print("%s" % data_name)
    for classifier in classifiers_list:
        classifier_path = os.path.split(classifier)[0]
        classifier_name = os.path.split(classifier)[1]
        outfile_name = "log/%s_%s.log" % (data_name, classifier_name)

        for eps in eps_list:
            print("eps = %s" %eps)
            cmd = "matlab -nodisplay -r \"cvgrid('%s', '%s', @%s, %s, %s, %s, %s, %s, %s, 1.0)\" > %s" % (data, classifier_path, classifier_name, nfold, cstart, ctimes, cstep, seed, eps, outfile_name)
            system(cmd)

            outfile = open(outfile_name, 'r')
            CG = 0
            for line in outfile.readlines():
                if find(line, "CG") != -1:
                    CG = CG + atoi(split(line)[-1])  
                if find(line, "CV") != -1:
                    print("%10s %6.2f %7.1f %5d" % (classifier_name, atof(split(line)[2]), atof(split(line)[4]), CG/nfold))
                    CG = 0
            outfile.close()
        
