#ifndef _LIBLR_H
#define _LIBLR_H

#ifdef __cplusplus
extern "C" {
#endif

struct lr_problem
{
	int l, n;
	double *y;
	double *x_val; 
	long int *x_jr, *x_ic;
};

enum { C_SVC, NU_SVC, ONE_CLASS, EPSILON_SVR, NU_SVR };	/* lr_type */

struct lr_parameter
{
	int lr_type;

	/* these are for training only */
	double eps;	/* stopping criteria */
	double C;	/* for C_SVC, EPSILON_SVR and NU_SVR */
	int nr_weight;		/* for C_SVC */
	int *weight_label;	/* for C_SVC */
	double* weight;		/* for C_SVC */
};

void lr_train(const struct lr_problem *prob, const struct lr_parameter *param, double *w);
void lr_destroy_param(struct lr_parameter *param);
const char *lr_check_parameter(const struct lr_problem *prob, const struct lr_parameter *param);

#ifdef __cplusplus
}
#endif

#endif /* _LIBLR_H */
